<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <title>40.30</title>
</head>

<body>
  <!-- Vùng header -->
  <div class="container">
    <div class="text-center">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
    </div>
  </div>
  <!-- Vouche Data Table -->
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="users-table">
      <thead>
        <tr>
          <th>Id</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
  <!-- Add user modal -->
  <div>
    <div id="add-user-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Add new user</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-add-user-firstname">First name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-add-user-firstname" name="UserFirstname" placeholder="Firstname..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-add-user-lastname">Last name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-add-user-lastname" name="UserLastname" placeholder="Lastname..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-add-user-subject">Subject</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-add-user-subject" name="UserSubject" placeholder="Subject..."
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-add-user-country">Country</label>
                </div>
                <div class="col-sm-8">
                  <select class="form-control" name="UserCountry" id="select-add-user-country">
                    <option value="0">Select your country</option>
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-add-user-customer-type">Customer Type</label>
                </div>
                <div class="col-sm-8">
                  <select class="form-control" name="UserCustomerType" id="select-add-user-customer-type">
                    <option value="0">Select your customer type</option>
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                  </select>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-success" id="btn-confirm-add-user">Insert user</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
  const gCONTENT_TYPE = "application/json;charset=UTF-8";


  const gNAME_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
  const gID_COL = 0;
  const gFIRSTNAME_COL = 1;
  const gLASTNAME_COL = 2;
  const gCOUNTRY_COL = 3;
  const gSUBJECT_COL = 4;
  const gCUSTOMER_TYPE_COL = 5;
  const gREGISTER_STATUS_COL = 6;
  const gACTION_COL = 7;
  var gDataUsersTable = $("#users-table").DataTable({
    columns: [
      { data: gNAME_COL[gID_COL] },
      { data: gNAME_COL[gFIRSTNAME_COL] },
      { data: gNAME_COL[gLASTNAME_COL] },
      { data: gNAME_COL[gCOUNTRY_COL] },
      { data: gNAME_COL[gSUBJECT_COL] },
      { data: gNAME_COL[gCUSTOMER_TYPE_COL] },
      { data: gNAME_COL[gREGISTER_STATUS_COL] },
      { data: gNAME_COL[gACTION_COL] },
    ],
    columnDefs: [
      {
        targets: gACTION_COL,
        defaultContent: `
                <div class= btn-group>
                <button class="btn btn-primary mr-2" id="btn-update-user">Sửa</button>
                <button class="btn btn-danger"  id="btn-delete-user">Xóa</button>
                </div>
                `
      }
    ]
  });
  //khởi tạo đối tượng user toàn cục:
  var gUserObj = {
    firstname: "",
    lastname: "",
    country: "",
    subject: "",
    customerType: "",
  }

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {

    onPageLoading();
    //gán sự kiện cho nút Sửa
    $("#users-table").on("click", "#btn-update-user", function () {
      onBtnUpdateUserClick(this)
    });
    //gán sự kiện cho nút Xóa

    $("#users-table").on("click", "#btn-delete-user", function () {
      onBtnDeleteUserClick(this)
    });
    //gán sự kiện cho nút Thêm user

    $(document).on("click", "#btn-add-user", function () {
      $("#add-user-modal").modal("show");
    });
    //gán sự kiện cho nút Insert user (trên modal):
    $("#add-user-modal").on("click", "#btn-confirm-add-user", function() {
      onBtnInsertUserClick(gUserObj)
    });
  });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
      getUserList()
    }
    //hàm ấn nút Sửa:
    function onBtnUpdateUserClick(paramBtnUpdate) {
      var vTableRow = $(paramBtnUpdate).parents("tr");
      var vDataTableRow = gDataUsersTable.row(vTableRow);
      var vUserIdObj = vDataTableRow.data().id;
      console.log(vUserIdObj);

    }
    //hàm ấn nút Xóa:
    function onBtnDeleteUserClick(paramBtnDelete) {
      var vTableRow = $(paramBtnDelete).parents("tr");
      var vDataTableRow = gDataUsersTable.row(vTableRow);
      var vUserIdObj = vDataTableRow.data().id;
      console.log(vUserIdObj);
    }
    //hàm ấn nút Insert User (trên modal):
    function onBtnInsertUserClick(paramUserObj){
      readDataUser (paramUserObj);
      var vDataValid = validateUserData(paramUserObj);
      if (vDataValid) {
        callApiToAddNewUser(paramUserObj)
      }
    }



    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi api lấy danh sách user từ server:
    function getUserList() {
      $.ajax({
        url: "http://203.171.20.210:8080/crud-api/users/",
        type: "GET",
        success: function (paramRes) {
          loadUserListToTable(paramRes)
        },
        error: function (paramErorr) {
          console.log(paramErorr.responseText)
        }
      });
    }
    //hàm load users list vào table:
    function loadUserListToTable(paramUserListObj) {
      gDataUsersTable.clear(),
        gDataUsersTable.rows.add(paramUserListObj),
        gDataUsersTable.draw()
    }
  

  //hàm đọc dữ liệu user nhập vào("trên modal"):
  function readDataUser (paramUserObj){
    paramUserObj.firstname = $.trim($("#input-add-user-firstname").val());
    paramUserObj.lastname = $.trim($("#input-add-user-lastname").val());
    paramUserObj.subject = $.trim($("#input-add-user-subject").val());
    paramUserObj.country = $("#select-add-user-country").val();
    paramUserObj.customerType = $("#select-add-user-customer-type").val();
  }

  //hàm validate dữ liệu user nhập vào("trên modal"):
  function validateUserData(paramUserObj){
    if (paramUserObj.firstname == "") {
      alert("Please input firstname");
      return false;
    }
    if (paramUserObj.lastname == "") {
      alert("Please input lastname");
      return false;
    }
    if (paramUserObj.subject == "") {
      alert("Please input subject");
      return false;
    }
    if (paramUserObj.country == "0") {
      alert("Please select your country");
      return false;
    }
    if (paramUserObj.customerType == "0") {
      alert("Please select your customer type");
      return false;
    }
    return true
  }
  //hàm gọi API để thêm user mới:
  function callApiToAddNewUser(paramUserObj){
    $.ajax({
      url: gBASE_URL,
      type: "POST",
      contentType: gCONTENT_TYPE,
      data: JSON.stringify(paramUserObj),
      success: function(paramRes){
        handleInsertUserSuccess()
      },
      error: function(paramErorr){
        console.log(paramErorr.responseText)
      }
    });
  }
  //hàm handle khi add user thành công:
  function handleInsertUserSuccess(){
    alert("Add user successfully");
    resertInsertUserForm();
    $("#add-user-modal").modal("hide");
    getUserList()  
  }

  //hàm xóa trắng form insert user:
  function resertInsertUserForm() {
    $("#input-add-user-firstname").val("");
    $("#input-add-user-lastname").val("") ;
    $("#input-add-user-subject").val("");
    $("#select-add-user-country").val("0")  ;
    $("#select-add-user-customer-type").val("0");
  }
</script>

</html>